//#include "MyCapture.h"
#include "MyFrameBuffer.h"
#include <cstdio>

extern int main_func (void* ptr, unsigned int w, unsigned int h);
extern int output(const char*pszFileName, unsigned short* dst);


void StartHere(void)
{
//	MRC p15,0,r0,c1,c0,2    // Read CP Access register
//	ORR r0,r0,#0x00f00000   // Enable full access to NEON/VFP (Coprocessors 10 and 11)
//	MCR p15,0,r0,c1,c0,2    // Write CP Access register
//	ISB
//	MOV r0,#0x40000000      // Switch on the VFP and NEON hardware
//	MSR FPEXC,r0            // Set EN bit in FPEXC
//	IMPORT __main
//	B __main                // Enter normal C run-time environment & library start-up

    asm("MRC p15, #0, r1, c1, c0, #2\n\t" // ; r1 = Access Control Register\n\t");
    "ORR r1, r1, #(0xf << 20)\n" // ; enable full access for p10,11
    "MCR p15, #0, r1, c1, c0, #2\n" // ; Access Control Register = r1
    "MOV r1, #0\n"
    "MCR p15, #0, r1, c7, c5, #4\n" // ; flush prefetch buffer because of FMXR below
    //; and CP 10 & 11 were only just enabled
    //; Enable VFP itself
    "MOV r0,#0x40000000\n"
    "FMXR FPEXC, r0\n");// ; FPEXC = r0
}


int main()
{
	//StartHere();
    MyFrameBuffer myFB;

    //MyVideoCapture myCapture;
    if (myFB.init())
    {
    	printf("width=%d, height=%d\n", myFB.getWidth(), myFB.getHeight());
    	//myFB.draw();
    	main_func(myFB.getPtr(), myFB.getWidth(), myFB.getHeight());
    	//output("Fan-Bing-Bing-115.bmp", (unsigned short*)myFB.getPtr());
    }
    return 0;
}
